<template>
  <section id="vlue-dev-font-select"
    :class="{ display : Object.keys(fontSelectParams).length }">
    <section id="vlue-dev-font-select-top">
      <h3>Font Select</h3>
      <input class="vlue-dev-sidebar-button vlue-dev-sidebar-back-button"
        type="button"
        v-on:click="hideFontSelect()"
        value="<">
    </section>
    <section id="vlue-dev-font-select-main">
      <sidebar-property-field
        :current="fontSelectParams.current"
        :global="fontSelectParams.global"
        :prop="prop('')">
      </sidebar-property-field>
      <sidebar-property-field
        v-for="(font, index) in fonts"
        :current="fontSelectParams.current"
        :global="fontSelectParams.global"
        :prop="prop(font)"
        :key="index">
      </sidebar-property-field>
    </section>
  </section>
</template>

<script lang="ts">
import Vue from 'vue'
import sidebarPropertyField from './SidebarPropertyField.vue'
import store from '../../store/store'
import { mapState } from 'vuex'

export default Vue.extend({
  computed: {
    ...mapState([
      'fontSelectParams',
      'fonts',
    ]),
  },
  components: {
    sidebarPropertyField,
  },
  methods: {
    hideFontSelect() {
      store.commit('hideFontSelect');
    },
    prop(font) {
      return {
        ...this.fontSelectParams.property,
        value: font,
      };
    },
  },
})
</script>

<style lang="scss">
@import "../../style/vars.scss";

.vlue-dev-sidebar-font-select-button {
  background-size: cover;
  background-position: center;
  font-size: 15px;
  padding: 20px;
  white-space: normal;
  height: 100px;
  border: 0 solid rgba(0,0,0,0.5);
  background-color: rgba(0,0,0,0.4);
  box-shadow: inset 0 10px 10px rgba(0,0,0,0.2);
  &:enabled:not(.selected) {
    &:hover {
      border-width: 10px;
      padding: 10px;
    }
    &:hover,
    &:active {
      box-shadow: 0 0 10px rgba(0,0,0,0.75) inset;
    }
  }
}

#vlue-dev-font-select {
  display: none;
  overflow: hidden;
  flex-direction: column;
  position: fixed;
  top: 0;
  right: - $vlue-dev-sidebar-width;
  width: $vlue-dev-sidebar-width;
  height: 100vh;
  background: $vlue-dev-bg-color;
  transition: $vlue-transition-duration;
  &.display {
    right: - $standard-scrollbar-width;
  }
  #vlue-dev-font-select-top {
    padding-top: 10px;
    box-shadow: 0 10px 10px rgba(0,0,0,0.5);
    * {
      margin: 10px;
      width: calc(100% - 40px);
    }
  }
  #vlue-dev-font-select-main {
    overflow: auto;
    padding: 50px 0;
  }
}
.dev #vlue-dev-font-select {
  display: flex;
}
</style>
